/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.TradeAnalysisPanes;

import org.jfree.chart.JFreeChart;

import com.strategyquant.lib.charts.common.SQBarChart;
import com.strategyquant.lib.language.L;
import com.strategyquant.lib.results.SQData;
import com.strategyquant.lib.results.SQOrder;
import com.strategyquant.lib.results.SQOrderList;
import com.strategyquant.lib.results.SQResultsGroup;
import com.strategyquant.lib.settings.SQConst;
import com.strategyquant.lib.snippets.TradeAnalysisChartPane;

public class LongShortProfitLossChart extends TradeAnalysisChartPane {

	public LongShortProfitLossChart() {
		this.name = L.t("Long vs Short P/L");
	}
	
	@Override
	public JFreeChart drawChart(SQResultsGroup strategyResult, SQData data) {
		SQBarChart chart = new SQBarChart();
		chart.xLegend = L.t("P/L / Order type");
		
		if(strategyResult==null) {
			return chart.render();
		}
		
		double[] pl = computeData(strategyResult, data);

		chart.setValue(pl[0], "P/L", L.t("Long P/L"));
		chart.setValue(pl[1], "P/L", L.t("Short P/L"));
		
		chart.invertIfNegative(true);
		
		return chart.render();
	}

	private double[] computeData(SQResultsGroup strategyResult, SQData data) {
		String plType = data.getString("plType", SQConst.PL_IN_MONEY);
		
		SQOrderList orderList = filterOrders(strategyResult, data);
		
		double[] pl = new double[2]; //long, short
		
		for(int i=0; i<pl.length; i++) { 
			pl[i]=0; 
		}

		for(SQOrder order : orderList) {
			if(order.Type==SQConst.ORDER_BUY) { //long
				pl[0]+=order.getPL(plType);  
			} else { //short
				pl[1]+=order.getPL(plType);
			}
		}
		
		return pl;
	}
}